% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.ioaorkf.R, R/plot.rkf.R
\name{plot}
\alias{plot}
\alias{plot.ioaorkf}
\alias{plot.rkf}
\title{plot}
\usage{
\method{plot}{ioaorkf}(x, time = NULL, horizon = NULL, subset = NULL, ...)

\method{plot}{rkf}(x, time = NULL, subset = NULL, conf_level = 0.95, ...)
}
\arguments{
\item{x}{An instance of an \code{ioaorkf} or \code{rkf} S3 class.}

\item{time}{A positive integer giving the time at which the output is to be displayed. It defaults to the number of observations.}

\item{horizon}{A positive integer giving the smoothing horizon that is to be used. It must be at least equal to the number of rows of the horizonmatrix used to obtain the ioaorkf object.}

\item{subset}{A list of integers indicating the components of observations which are to be plotted.}

\item{...}{Ignored.}

\item{conf_level}{A probability between 0 and 1 giving the confidence level at which the series are to be tested against anomalies. It defaults to 0.95.}
}
\value{
A ggplot object.
}
\description{
A function to plot the output produced by \code{\link{AORKF_t}}, \code{\link{AORKF_huber}}, \code{\link{IORKF_huber}} or \code{\link{IOAORKF}}.
One can specify a time during the run for which the output should be displayed.
}
